<?php

namespace ArtabanMarketplace\Model\Base;

use \Exception;
use \PDO;
use ArtabanMarketplace\Model\AmpSellerOrderDeliveryReference as ChildAmpSellerOrderDeliveryReference;
use ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceQuery as ChildAmpSellerOrderDeliveryReferenceQuery;
use ArtabanMarketplace\Model\Map\AmpSellerOrderDeliveryReferenceTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveQuery\ModelJoin;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\PropelException;

/**
 * Base class that represents a query for the 'amp_seller_order_delivery_reference' table.
 *
 *
 *
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery orderByOrderSellerId($order = Criteria::ASC) Order by the order_seller_id column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery orderByDeliveryReference($order = Criteria::ASC) Order by the delivery_reference column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery orderByCreatedAt($order = Criteria::ASC) Order by the created_at column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery orderByUpdatedAt($order = Criteria::ASC) Order by the updated_at column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery orderByVersion($order = Criteria::ASC) Order by the version column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery orderByVersionCreatedAt($order = Criteria::ASC) Order by the version_created_at column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery orderByVersionCreatedBy($order = Criteria::ASC) Order by the version_created_by column
 *
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery groupById() Group by the id column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery groupByOrderSellerId() Group by the order_seller_id column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery groupByDeliveryReference() Group by the delivery_reference column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery groupByCreatedAt() Group by the created_at column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery groupByUpdatedAt() Group by the updated_at column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery groupByVersion() Group by the version column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery groupByVersionCreatedAt() Group by the version_created_at column
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery groupByVersionCreatedBy() Group by the version_created_by column
 *
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery leftJoinAmpSellerOrder($relationAlias = null) Adds a LEFT JOIN clause to the query using the AmpSellerOrder relation
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery rightJoinAmpSellerOrder($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AmpSellerOrder relation
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery innerJoinAmpSellerOrder($relationAlias = null) Adds a INNER JOIN clause to the query using the AmpSellerOrder relation
 *
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery leftJoinAmpSellerOrderDeliveryReferenceVersion($relationAlias = null) Adds a LEFT JOIN clause to the query using the AmpSellerOrderDeliveryReferenceVersion relation
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery rightJoinAmpSellerOrderDeliveryReferenceVersion($relationAlias = null) Adds a RIGHT JOIN clause to the query using the AmpSellerOrderDeliveryReferenceVersion relation
 * @method     ChildAmpSellerOrderDeliveryReferenceQuery innerJoinAmpSellerOrderDeliveryReferenceVersion($relationAlias = null) Adds a INNER JOIN clause to the query using the AmpSellerOrderDeliveryReferenceVersion relation
 *
 * @method     ChildAmpSellerOrderDeliveryReference findOne(ConnectionInterface $con = null) Return the first ChildAmpSellerOrderDeliveryReference matching the query
 * @method     ChildAmpSellerOrderDeliveryReference findOneOrCreate(ConnectionInterface $con = null) Return the first ChildAmpSellerOrderDeliveryReference matching the query, or a new ChildAmpSellerOrderDeliveryReference object populated from the query conditions when no match is found
 *
 * @method     ChildAmpSellerOrderDeliveryReference findOneById(int $id) Return the first ChildAmpSellerOrderDeliveryReference filtered by the id column
 * @method     ChildAmpSellerOrderDeliveryReference findOneByOrderSellerId(int $order_seller_id) Return the first ChildAmpSellerOrderDeliveryReference filtered by the order_seller_id column
 * @method     ChildAmpSellerOrderDeliveryReference findOneByDeliveryReference(string $delivery_reference) Return the first ChildAmpSellerOrderDeliveryReference filtered by the delivery_reference column
 * @method     ChildAmpSellerOrderDeliveryReference findOneByCreatedAt(string $created_at) Return the first ChildAmpSellerOrderDeliveryReference filtered by the created_at column
 * @method     ChildAmpSellerOrderDeliveryReference findOneByUpdatedAt(string $updated_at) Return the first ChildAmpSellerOrderDeliveryReference filtered by the updated_at column
 * @method     ChildAmpSellerOrderDeliveryReference findOneByVersion(int $version) Return the first ChildAmpSellerOrderDeliveryReference filtered by the version column
 * @method     ChildAmpSellerOrderDeliveryReference findOneByVersionCreatedAt(string $version_created_at) Return the first ChildAmpSellerOrderDeliveryReference filtered by the version_created_at column
 * @method     ChildAmpSellerOrderDeliveryReference findOneByVersionCreatedBy(string $version_created_by) Return the first ChildAmpSellerOrderDeliveryReference filtered by the version_created_by column
 *
 * @method     array findById(int $id) Return ChildAmpSellerOrderDeliveryReference objects filtered by the id column
 * @method     array findByOrderSellerId(int $order_seller_id) Return ChildAmpSellerOrderDeliveryReference objects filtered by the order_seller_id column
 * @method     array findByDeliveryReference(string $delivery_reference) Return ChildAmpSellerOrderDeliveryReference objects filtered by the delivery_reference column
 * @method     array findByCreatedAt(string $created_at) Return ChildAmpSellerOrderDeliveryReference objects filtered by the created_at column
 * @method     array findByUpdatedAt(string $updated_at) Return ChildAmpSellerOrderDeliveryReference objects filtered by the updated_at column
 * @method     array findByVersion(int $version) Return ChildAmpSellerOrderDeliveryReference objects filtered by the version column
 * @method     array findByVersionCreatedAt(string $version_created_at) Return ChildAmpSellerOrderDeliveryReference objects filtered by the version_created_at column
 * @method     array findByVersionCreatedBy(string $version_created_by) Return ChildAmpSellerOrderDeliveryReference objects filtered by the version_created_by column
 *
 */
abstract class AmpSellerOrderDeliveryReferenceQuery extends ModelCriteria
{

    // versionable behavior

    /**
     * Whether the versioning is enabled
     */
    static $isVersioningEnabled = true;

    /**
     * Initializes internal state of \ArtabanMarketplace\Model\Base\AmpSellerOrderDeliveryReferenceQuery object.
     *
     * @param     string $dbName The database name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = 'thelia', $modelName = '\\ArtabanMarketplace\\Model\\AmpSellerOrderDeliveryReference', $modelAlias = null)
    {
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ChildAmpSellerOrderDeliveryReferenceQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param     Criteria $criteria Optional Criteria to build the query from
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceQuery) {
            return $criteria;
        }
        $query = new \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceQuery();
        if (null !== $modelAlias) {
            $query->setModelAlias($modelAlias);
        }
        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return ChildAmpSellerOrderDeliveryReference|array|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = AmpSellerOrderDeliveryReferenceTableMap::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(AmpSellerOrderDeliveryReferenceTableMap::DATABASE_NAME);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @return   ChildAmpSellerOrderDeliveryReference A model object, or null if the key is not found
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT ID, ORDER_SELLER_ID, DELIVERY_REFERENCE, CREATED_AT, UPDATED_AT, VERSION, VERSION_CREATED_AT, VERSION_CREATED_BY FROM amp_seller_order_delivery_reference WHERE ID = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), 0, $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(\PDO::FETCH_NUM)) {
            $obj = new ChildAmpSellerOrderDeliveryReference();
            $obj->hydrate($row);
            AmpSellerOrderDeliveryReferenceTableMap::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @return ChildAmpSellerOrderDeliveryReference|array|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($dataFetcher);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     ConnectionInterface $con an optional connection object
     *
     * @return ObjectCollection|array|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getReadConnection($this->getDbName());
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($dataFetcher);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id > 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ID, $id, $comparison);
    }

    /**
     * Filter the query on the order_seller_id column
     *
     * Example usage:
     * <code>
     * $query->filterByOrderSellerId(1234); // WHERE order_seller_id = 1234
     * $query->filterByOrderSellerId(array(12, 34)); // WHERE order_seller_id IN (12, 34)
     * $query->filterByOrderSellerId(array('min' => 12)); // WHERE order_seller_id > 12
     * </code>
     *
     * @see       filterByAmpSellerOrder()
     *
     * @param     mixed $orderSellerId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByOrderSellerId($orderSellerId = null, $comparison = null)
    {
        if (is_array($orderSellerId)) {
            $useMinMax = false;
            if (isset($orderSellerId['min'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ORDER_SELLER_ID, $orderSellerId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($orderSellerId['max'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ORDER_SELLER_ID, $orderSellerId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ORDER_SELLER_ID, $orderSellerId, $comparison);
    }

    /**
     * Filter the query on the delivery_reference column
     *
     * Example usage:
     * <code>
     * $query->filterByDeliveryReference('fooValue');   // WHERE delivery_reference = 'fooValue'
     * $query->filterByDeliveryReference('%fooValue%'); // WHERE delivery_reference LIKE '%fooValue%'
     * </code>
     *
     * @param     string $deliveryReference The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByDeliveryReference($deliveryReference = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($deliveryReference)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $deliveryReference)) {
                $deliveryReference = str_replace('*', '%', $deliveryReference);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::DELIVERY_REFERENCE, $deliveryReference, $comparison);
    }

    /**
     * Filter the query on the created_at column
     *
     * Example usage:
     * <code>
     * $query->filterByCreatedAt('2011-03-14'); // WHERE created_at = '2011-03-14'
     * $query->filterByCreatedAt('now'); // WHERE created_at = '2011-03-14'
     * $query->filterByCreatedAt(array('max' => 'yesterday')); // WHERE created_at > '2011-03-13'
     * </code>
     *
     * @param     mixed $createdAt The value to use as filter.
     *              Values can be integers (unix timestamps), DateTime objects, or strings.
     *              Empty strings are treated as NULL.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByCreatedAt($createdAt = null, $comparison = null)
    {
        if (is_array($createdAt)) {
            $useMinMax = false;
            if (isset($createdAt['min'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::CREATED_AT, $createdAt['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($createdAt['max'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::CREATED_AT, $createdAt['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::CREATED_AT, $createdAt, $comparison);
    }

    /**
     * Filter the query on the updated_at column
     *
     * Example usage:
     * <code>
     * $query->filterByUpdatedAt('2011-03-14'); // WHERE updated_at = '2011-03-14'
     * $query->filterByUpdatedAt('now'); // WHERE updated_at = '2011-03-14'
     * $query->filterByUpdatedAt(array('max' => 'yesterday')); // WHERE updated_at > '2011-03-13'
     * </code>
     *
     * @param     mixed $updatedAt The value to use as filter.
     *              Values can be integers (unix timestamps), DateTime objects, or strings.
     *              Empty strings are treated as NULL.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByUpdatedAt($updatedAt = null, $comparison = null)
    {
        if (is_array($updatedAt)) {
            $useMinMax = false;
            if (isset($updatedAt['min'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::UPDATED_AT, $updatedAt['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($updatedAt['max'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::UPDATED_AT, $updatedAt['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::UPDATED_AT, $updatedAt, $comparison);
    }

    /**
     * Filter the query on the version column
     *
     * Example usage:
     * <code>
     * $query->filterByVersion(1234); // WHERE version = 1234
     * $query->filterByVersion(array(12, 34)); // WHERE version IN (12, 34)
     * $query->filterByVersion(array('min' => 12)); // WHERE version > 12
     * </code>
     *
     * @param     mixed $version The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByVersion($version = null, $comparison = null)
    {
        if (is_array($version)) {
            $useMinMax = false;
            if (isset($version['min'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::VERSION, $version['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($version['max'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::VERSION, $version['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::VERSION, $version, $comparison);
    }

    /**
     * Filter the query on the version_created_at column
     *
     * Example usage:
     * <code>
     * $query->filterByVersionCreatedAt('2011-03-14'); // WHERE version_created_at = '2011-03-14'
     * $query->filterByVersionCreatedAt('now'); // WHERE version_created_at = '2011-03-14'
     * $query->filterByVersionCreatedAt(array('max' => 'yesterday')); // WHERE version_created_at > '2011-03-13'
     * </code>
     *
     * @param     mixed $versionCreatedAt The value to use as filter.
     *              Values can be integers (unix timestamps), DateTime objects, or strings.
     *              Empty strings are treated as NULL.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByVersionCreatedAt($versionCreatedAt = null, $comparison = null)
    {
        if (is_array($versionCreatedAt)) {
            $useMinMax = false;
            if (isset($versionCreatedAt['min'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::VERSION_CREATED_AT, $versionCreatedAt['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($versionCreatedAt['max'])) {
                $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::VERSION_CREATED_AT, $versionCreatedAt['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::VERSION_CREATED_AT, $versionCreatedAt, $comparison);
    }

    /**
     * Filter the query on the version_created_by column
     *
     * Example usage:
     * <code>
     * $query->filterByVersionCreatedBy('fooValue');   // WHERE version_created_by = 'fooValue'
     * $query->filterByVersionCreatedBy('%fooValue%'); // WHERE version_created_by LIKE '%fooValue%'
     * </code>
     *
     * @param     string $versionCreatedBy The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByVersionCreatedBy($versionCreatedBy = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($versionCreatedBy)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $versionCreatedBy)) {
                $versionCreatedBy = str_replace('*', '%', $versionCreatedBy);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::VERSION_CREATED_BY, $versionCreatedBy, $comparison);
    }

    /**
     * Filter the query by a related \ArtabanMarketplace\Model\AmpSellerOrder object
     *
     * @param \ArtabanMarketplace\Model\AmpSellerOrder|ObjectCollection $ampSellerOrder The related object(s) to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByAmpSellerOrder($ampSellerOrder, $comparison = null)
    {
        if ($ampSellerOrder instanceof \ArtabanMarketplace\Model\AmpSellerOrder) {
            return $this
                ->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ORDER_SELLER_ID, $ampSellerOrder->getId(), $comparison);
        } elseif ($ampSellerOrder instanceof ObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ORDER_SELLER_ID, $ampSellerOrder->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByAmpSellerOrder() only accepts arguments of type \ArtabanMarketplace\Model\AmpSellerOrder or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AmpSellerOrder relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function joinAmpSellerOrder($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AmpSellerOrder');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AmpSellerOrder');
        }

        return $this;
    }

    /**
     * Use the AmpSellerOrder relation AmpSellerOrder object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderQuery A secondary query class using the current class as primary query
     */
    public function useAmpSellerOrderQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAmpSellerOrder($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AmpSellerOrder', '\ArtabanMarketplace\Model\AmpSellerOrderQuery');
    }

    /**
     * Filter the query by a related \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceVersion object
     *
     * @param \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceVersion|ObjectCollection $ampSellerOrderDeliveryReferenceVersion  the related object to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function filterByAmpSellerOrderDeliveryReferenceVersion($ampSellerOrderDeliveryReferenceVersion, $comparison = null)
    {
        if ($ampSellerOrderDeliveryReferenceVersion instanceof \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceVersion) {
            return $this
                ->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ID, $ampSellerOrderDeliveryReferenceVersion->getId(), $comparison);
        } elseif ($ampSellerOrderDeliveryReferenceVersion instanceof ObjectCollection) {
            return $this
                ->useAmpSellerOrderDeliveryReferenceVersionQuery()
                ->filterByPrimaryKeys($ampSellerOrderDeliveryReferenceVersion->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByAmpSellerOrderDeliveryReferenceVersion() only accepts arguments of type \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceVersion or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the AmpSellerOrderDeliveryReferenceVersion relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function joinAmpSellerOrderDeliveryReferenceVersion($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('AmpSellerOrderDeliveryReferenceVersion');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'AmpSellerOrderDeliveryReferenceVersion');
        }

        return $this;
    }

    /**
     * Use the AmpSellerOrderDeliveryReferenceVersion relation AmpSellerOrderDeliveryReferenceVersion object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceVersionQuery A secondary query class using the current class as primary query
     */
    public function useAmpSellerOrderDeliveryReferenceVersionQuery($relationAlias = null, $joinType = Criteria::INNER_JOIN)
    {
        return $this
            ->joinAmpSellerOrderDeliveryReferenceVersion($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'AmpSellerOrderDeliveryReferenceVersion', '\ArtabanMarketplace\Model\AmpSellerOrderDeliveryReferenceVersionQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   ChildAmpSellerOrderDeliveryReference $ampSellerOrderDeliveryReference Object to remove from the list of results
     *
     * @return ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function prune($ampSellerOrderDeliveryReference = null)
    {
        if ($ampSellerOrderDeliveryReference) {
            $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::ID, $ampSellerOrderDeliveryReference->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

    /**
     * Deletes all rows from the amp_seller_order_delivery_reference table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public function doDeleteAll(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerOrderDeliveryReferenceTableMap::DATABASE_NAME);
        }
        $affectedRows = 0; // initialize var to track total num of affected rows
        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->beginTransaction();
            $affectedRows += parent::doDeleteAll($con);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            AmpSellerOrderDeliveryReferenceTableMap::clearInstancePool();
            AmpSellerOrderDeliveryReferenceTableMap::clearRelatedInstancePool();

            $con->commit();
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }

        return $affectedRows;
    }

    /**
     * Performs a DELETE on the database, given a ChildAmpSellerOrderDeliveryReference or Criteria object OR a primary key value.
     *
     * @param mixed               $values Criteria or ChildAmpSellerOrderDeliveryReference object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
     public function delete(ConnectionInterface $con = null)
     {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerOrderDeliveryReferenceTableMap::DATABASE_NAME);
        }

        $criteria = $this;

        // Set the correct dbName
        $criteria->setDbName(AmpSellerOrderDeliveryReferenceTableMap::DATABASE_NAME);

        $affectedRows = 0; // initialize var to track total num of affected rows

        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->beginTransaction();


        AmpSellerOrderDeliveryReferenceTableMap::removeInstanceFromPool($criteria);

            $affectedRows += ModelCriteria::delete($con);
            AmpSellerOrderDeliveryReferenceTableMap::clearRelatedInstancePool();
            $con->commit();

            return $affectedRows;
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }
    }

    // timestampable behavior

    /**
     * Filter by the latest updated
     *
     * @param      int $nbDays Maximum age of the latest update in days
     *
     * @return     ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function recentlyUpdated($nbDays = 7)
    {
        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::UPDATED_AT, time() - $nbDays * 24 * 60 * 60, Criteria::GREATER_EQUAL);
    }

    /**
     * Filter by the latest created
     *
     * @param      int $nbDays Maximum age of in days
     *
     * @return     ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function recentlyCreated($nbDays = 7)
    {
        return $this->addUsingAlias(AmpSellerOrderDeliveryReferenceTableMap::CREATED_AT, time() - $nbDays * 24 * 60 * 60, Criteria::GREATER_EQUAL);
    }

    /**
     * Order by update date desc
     *
     * @return     ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function lastUpdatedFirst()
    {
        return $this->addDescendingOrderByColumn(AmpSellerOrderDeliveryReferenceTableMap::UPDATED_AT);
    }

    /**
     * Order by update date asc
     *
     * @return     ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function firstUpdatedFirst()
    {
        return $this->addAscendingOrderByColumn(AmpSellerOrderDeliveryReferenceTableMap::UPDATED_AT);
    }

    /**
     * Order by create date desc
     *
     * @return     ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function lastCreatedFirst()
    {
        return $this->addDescendingOrderByColumn(AmpSellerOrderDeliveryReferenceTableMap::CREATED_AT);
    }

    /**
     * Order by create date asc
     *
     * @return     ChildAmpSellerOrderDeliveryReferenceQuery The current query, for fluid interface
     */
    public function firstCreatedFirst()
    {
        return $this->addAscendingOrderByColumn(AmpSellerOrderDeliveryReferenceTableMap::CREATED_AT);
    }

    // versionable behavior

    /**
     * Checks whether versioning is enabled
     *
     * @return boolean
     */
    static public function isVersioningEnabled()
    {
        return self::$isVersioningEnabled;
    }

    /**
     * Enables versioning
     */
    static public function enableVersioning()
    {
        self::$isVersioningEnabled = true;
    }

    /**
     * Disables versioning
     */
    static public function disableVersioning()
    {
        self::$isVersioningEnabled = false;
    }

} // AmpSellerOrderDeliveryReferenceQuery
